"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withPlayroom = void 0;

var _utils = require("playroom/utils");

var _react = _interopRequireDefault(require("react"));

var _reactElementToJsxString = _interopRequireDefault(require("react-element-to-jsx-string"));

var _addons = require("@storybook/addons");

var _constants = require("./constants");

var _utils2 = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable import/prefer-default-export */
var Story = function Story(_ref) {
  var getStory = _ref.getStory,
      context = _ref.context,
      parameters = _ref.settings.parameters;

  var _getOptions = (0, _utils2.getOptions)(parameters),
      url = _getOptions.url,
      code = _getOptions.code,
      reactElementToJSXStringOptions = _getOptions.reactElementToJSXStringOptions;

  var story = getStory(context);
  var jsxString = code || (0, _reactElementToJsxString.default)(story, reactElementToJSXStringOptions);

  var channel = _addons.addons.getChannel();

  var codeUrl = url && (0, _utils.createUrl)({
    baseUrl: url,
    code: jsxString
  });
  channel.emit(_constants.EVENTS.UPDATE, codeUrl);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, story);
};

var withPlayroom = (0, _addons.makeDecorator)({
  name: 'withPlayroom',
  parameterName: _constants.PARAM_KEY,
  wrapper: function wrapper(getStory, context, settings) {
    return /*#__PURE__*/_react.default.createElement(Story, {
      getStory: getStory,
      context: context,
      settings: settings
    });
  }
});
exports.withPlayroom = withPlayroom;