/* eslint-disable import/prefer-default-export */
import { createUrl } from 'playroom/utils';
import React from 'react';
import reactElementToJSXString from 'react-element-to-jsx-string';
import { addons, makeDecorator } from '@storybook/addons';
import { EVENTS, PARAM_KEY } from './constants';
import { getOptions } from './utils';

var Story = function Story(_ref) {
  var getStory = _ref.getStory,
      context = _ref.context,
      parameters = _ref.settings.parameters;

  var _getOptions = getOptions(parameters),
      url = _getOptions.url,
      code = _getOptions.code,
      reactElementToJSXStringOptions = _getOptions.reactElementToJSXStringOptions;

  var story = getStory(context);
  var jsxString = code || reactElementToJSXString(story, reactElementToJSXStringOptions);
  var channel = addons.getChannel();
  var codeUrl = url && createUrl({
    baseUrl: url,
    code: jsxString
  });
  channel.emit(EVENTS.UPDATE, codeUrl);
  return /*#__PURE__*/React.createElement(React.Fragment, null, story);
};

export var withPlayroom = makeDecorator({
  name: 'withPlayroom',
  parameterName: PARAM_KEY,
  wrapper: function wrapper(getStory, context, settings) {
    return /*#__PURE__*/React.createElement(Story, {
      getStory: getStory,
      context: context,
      settings: settings
    });
  }
});